<?php
/*
Plugin Name: 1 Blog Title Generator
Plugin URI: http://1-blog-title-generator.es.javier-garcia.com/
Description: Mejora los t&iacute;tulos y etiquetas meta de tu blog usando toda la informaci&oacute;n disponible (descripciones, etiquetas, categor&iacute;as...).
Version: 1.0
Author: Javier Garc&iacute;a
date: 2007-07-12
Author URI: http://es.javier-garcia.com/
License: Attribution - Non Commercial - Share Alike 2.5 - http://creativecommons.org/licenses/by-nc-sa/2.5/
*/

// PERSONALIZACIN

define("OBTG_SEPARATOR",": ");
define("OBTG_SITE_NAME_FIRST",false);
define("OBTG_REPLACE_TITLE",true);

/*
    * OBTG_SEPARATOR: Cadena de texto que servir como separacin de los distintos elementos del ttulo (por defecto ": ").
    * OBTG_SITE_NAME_FIRST: Opcin de incluir el nombre del sitio al principio del ttulo en vez de al final (false por defecto).
    * OBTG_REPLACE_TITLE: Opcin de reemplazar el ttulo automticamente sin tener que modificar el tema (true por defecto).

// INSTALACIN

    * (Opcional) Edita los valores del archivo advanced-cache.php (define...) a tu gusto (ms informacin en ese archivo).
    * Sube el plugin al directorio /wp-content/plugins/.
    * Ectiva el plugin en el panel de WordPress.
    * El plugin aadir automticamente las etiquetas meta. Adems reemplazar el ttulo usando una funcin de control del buffer de salida. Si quieres evitar esto (podra dar problemsa con otros plugins que usen tambin el buffer de salida), define la constante OBTG_REPLACE_TITLE como false y aade la funcin obtg_title() en el tema (normalmente en el archivo header.php):
        <title>[?php obtg_title() ?]</title>

// CARACTERSTICAS

    * Mejora los ttulos y etiquetas meta de tu blog sin necesidad de editar tu tema.
    * Elplugin es compatible con Simple Tagging Plugin, Ultimate Tag Warrior y el sistema de etiquetas de WordPress 2.3+.

*/
IF (!function_exists("obtg_title")){
	FUNCTION obtg_title(){
		global $obtg;
		IF (!is_array($obtg)) $obtg = obtg_generate();
		echo $obtg["title"];
	};
};
IF (!function_exists("obtg_generate")){
	FUNCTION obtg_generate(){
		global $obtg, $wp_locale, $paged, $posts, $post;
		$year = get_query_var("year");
		$monthnum = get_query_var("monthnum");
		$day = get_query_var("day");
		IF (!is_object($post)) $post = $posts[0];
		IF (is_home() || is_404()){
			$obtg["title"] = wp_specialchars(get_bloginfo("name"),true);
			IF (strlen(get_bloginfo("description"))) $obtg["title"] .= OBTG_SEPARATOR.wp_specialchars(get_bloginfo("description"),true);
			$obtg["description"] = wp_specialchars(obtg_first_titles(5),true);
		}ELSEIF (is_single() || is_page()){
			$obtg["title"] = apply_filters("the_title",$post->post_title);
			IF (!strlen($obtg["title"])) $obtg["title"] = __("Untitled");
			IF (strlen($post->post_password)) $obtg["title"] = sprintf(__("Protected: %s"),$obtg["title"]);
			$obtg["title"] = wp_specialchars($obtg["title"],true);
			$obtg["description"] = $obtg["title"];
			IF (!strlen($post->post_excerpt)){
				$post_excerpt = get_the_content();
				$post_excerpt = apply_filters("get_the_excerpt",$post_excerpt);
				$post_excerpt = apply_filters("the_excerpt",$post_excerpt);
				$post_excerpt = obtg_excerpt($post_excerpt);
			}ELSE{
				$post_excerpt = $post->post_excerpt;
				$post_excerpt = apply_filters("get_the_excerpt",$post->post_excerpt);
				$post_excerpt = apply_filters("the_excerpt",$post_excerpt);
				$post_excerpt = str_replace(array("<br />","</p>","</ul>","</ol>","</blockquote>","\n")," ",$post_excerpt);
				$post_excerpt = strip_tags($post_excerpt);
				WHILE (strpos($post_excerpt,"  ") !== false) $post_excerpt = str_replace("  "," ",$post_excerpt);
				$text = trim($post_excerpt);
			};
			IF (strlen($post_excerpt)) $obtg["description"] .= OBTG_SEPARATOR.$post_excerpt;
		}ELSEIF (is_category()){
			$obtg["title"] = $obtg["description"] = wp_specialchars(ucfirst(single_cat_title("",false)),true);
			$obtg_category_description = category_description();
			IF (trim($obtg_category_description) == "</p>") $obtg_category_description = "";
			IF (strlen($obtg_category_description)) $obtg["title"] .= OBTG_SEPARATOR.obtg_excerpt($obtg_category_description,10);
			$obtg["description"] .= OBTG_SEPARATOR.wp_specialchars(obtg_first_titles(5),true);
			unset($obtg_category);
		}ELSE{
			IF (obtg_is_tag()) $obtg["title"] = $obtg["description"] = ucfirst(obtg_current_tag());
			ELSEIF (is_search()){
				$obtg["title"] = $obtg["description"] = wp_specialchars(ucfirst($s),true);
				IF ($obtg_tags = wp_specialchars(ucfirst(obtg_tag_keywords(3,$s)),true)) $obtg["title"] .= OBTG_SEPARATOR.$obtg_tags;
			}ELSEIF (is_year()) $obtg["title"] = $obtg["description"] = $year;
			ELSEIF (is_month()) $obtg["title"] = $obtg["description"] = $wp_locale->get_month($monthnum).OBTG_SEPARATOR.$year;
			ELSEIF (is_day()) $obtg["title"] = $obtg["description"] = $wp_locale->get_month($monthnum).OBTG_SEPARATOR.$year.OBTG_SEPARATOR.zeroise($day,2);
			ELSEIF (is_author()){
				global $authordata;
				$authordata = get_userdata($post->post_author);
				$obtg["title"] = $obtg["description"] = wp_specialchars(get_the_author_nickname(),true);
			};
			$obtg["description"] .= OBTG_SEPARATOR.wp_specialchars(obtg_first_titles(5),true);
		};
		IF (!is_404()) IF (is_category()){
			IF (!strlen($obtg_category_description)) IF ($obtg_tags = wp_specialchars(ucfirst(obtg_tag_keywords(3,single_cat_title("",false))),true)) $obtg["title"] .= OBTG_SEPARATOR.$obtg_tags;
			$obtg["keywords"] = wp_specialchars(ucfirst(single_cat_title("",false)),true);
			IF ($obtg_tags = wp_specialchars(obtg_tag_keywords(9,single_cat_title("",false)),true)) $obtg["keywords"] .= ", {$obtg_tags}";
		}ELSEIF (obtg_is_tag()){
			IF ($obtg_tags = wp_specialchars(ucfirst(obtg_tag_keywords(3,obtg_current_tag())),true)) $obtg["title"] .= OBTG_SEPARATOR.$obtg_tags;
			$obtg["keywords"] = wp_specialchars(ucfirst(obtg_current_tag()),true);
			IF ($obtg_tags = wp_specialchars(obtg_tag_keywords(9,obtg_current_tag()),true)) $obtg["keywords"] .= ", {$obtg_tags}";
		}ELSE{
			IF (is_date() || is_author()) $obtg["title"] .= OBTG_SEPARATOR.wp_specialchars(ucfirst(obtg_tag_keywords(3)));
			$obtg["keywords"] = wp_specialchars(ucfirst(obtg_tag_keywords()),true);
		};
		IF (!is_home() && !is_404()){
			IF (OBTG_SITE_NAME_FIRST) $obtg["title"] = wp_specialchars(get_bloginfo("name"),true).OBTG_SEPARATOR."{$obtg["title"]}";
			ELSE $obtg["title"] .= OBTG_SEPARATOR.wp_specialchars(get_bloginfo("name"),true);
		};
		RETURN $obtg;
	};
};
add_action("template_redirect","obtg_generate");
IF (!function_exists("obtg_output_buffer")){
	FUNCTION obtg_output_buffer(){
		IF (!is_feed() && OBTG_REPLACE_TITLE) ob_start("obtg_output_callback");
	};
};
IF (!function_exists("obtg_output_callback")){
	FUNCTION obtg_output_callback($content){
		$content = preg_replace_callback("'<title>(.*)</title>'siU","obtg_replace_title",$content);
		RETURN $content;
	};
};
add_action("template_redirect","obtg_output_buffer");
IF (!function_exists("obtg_replace_title")){
	FUNCTION obtg_replace_title($matches){
		global $obtg, $obtg_replaced_title;
		IF ($obtg_replaced_title) RETURN $matches[0];
		ELSE{
			$obtg_replaced_title = true;
			RETURN "<title>{$obtg["title"]}</title>";
		};
	};
};

IF (!function_exists("obtg_meta")){
	FUNCTION obtg_meta(){
		global $obtg, $obtg_meta_added;
		IF (!$obtg_meta_added){
			echo "<meta name=\"description\" content=\"{$obtg["description"]}\" />\n";
			echo "<meta name=\"keywords\" content=\"{$obtg["keywords"]}\" />\n";
		};
		$obtg_meta_added = true;
	};
};
IF (!function_exists("obtg_replace_title")){
	FUNCTION obtg_replace_title($title){
		global $obtg;
		RETURN $obtg["title"];
	};
};
add_action("wp_meta","obtg_meta");
add_action("wp_head","obtg_meta");

FUNCTION obtg_first_titles($total_posts){
	global $posts;
	$first_titles = "";
	FOR ($x = 0; $x < min($total_posts,count($posts)); $x++){
		$title = apply_filters("the_title",$posts[$x]->post_title);
		IF (!strlen($title)) $title = __("Untitled");
		$first_titles .= $title;
		IF (substr($posts[$x]->post_title,0,-1) != ".") $first_titles .= ".";
		IF ($x !=  min($total_posts,count($posts))-1) $first_titles .= " ";
	};
	RETURN $first_titles;
};
FUNCTION obtg_excerpt($text,$total_words = 55){
	$text = str_replace(array("<br />","</p>","</ul>","</ol>","</blockquote>","\n")," ",$text);
	$text = strip_tags($text);
	$words = explode(" ",$text,$total_words+1);
	IF (count($words) > $total_words){
		array_pop($words);
		$text = implode(" ",$words);
		IF (substr($text,-3) != "..."){
			WHILE (in_array(substr($text,-1),array(".",",",";",":"))) $text = substr($text,0,-1);
			$text .= "...";
		};
	};
	WHILE (strpos($text,"  ") !== false) $text = str_replace("  "," ",$text);
	$text = trim($text);
	RETURN $text;
};
FUNCTION obtg_current_tag(){
	IF (function_exists("single_tag_title")){
		RETURN single_tag_title("",false);
	}ELSEIF (function_exists("UTW_ShowCurrentTagSet")){
		global $utw;
		$tagset = $utw->GetCurrentTagSet();
		FOREACH ($tagset as $tag) $tags .= "{$tag->tag}, ";
		RETURN substr($tags,0,-2);
	}ELSEIF (function_exists("STP_GetCurrentTagSet")) RETURN STP_GetCurrentTagSet();
};
FUNCTION obtg_is_tag(){
	IF (function_exists("is_tag")) RETURN is_tag();
	ELSEIF (function_exists("STP_IsTagView")) RETURN STP_IsTagView();
	RETURN false;
};
FUNCTION obtg_tag_in_title($title,$tag){
	$title = str_replace(array("<",">"),"",$title);
	$title = str_replace(array(":",".",",","/","\\")," ",$title);
	$title = sanitize_title($title);
	$tag = str_replace(array("<",">"),"",$tag);
	$tag = str_replace(array(":",".",",","/","\\")," ",$tag);
	$tag = sanitize_title($tag);
	IF (!strlen($tag)) RETURN false;
	IF (strpos($title,$tag) !== false) RETURN true;
	$tag = explode("-",$tag);
	FOREACH ($tag as $word){
		$words++;
		IF (strlen($word) > 3) $long_words++;
		IF (strpos($title,$word) !== false){
			$match_words++;
			IF (strlen($word) > 4) $long_match_words++;
		};
	};
	IF ($long_words) RETURN ($long_match_words >= $long_words/2);
	ELSE RETURN ($match_words >= $words/2);
};
FUNCTION obtg_tag_keywords($total_keywords = 10,$exclude = ""){
	global $posts, $obtg_tag_keywords;
	IF (!is_array($obtg_tag_keywords)){
		$tag_keywords = array();
		IF (count($posts)){
			IF (function_exists("get_the_tags")){
				FOREACH ($posts as $x=>$post) IF ($tags = get_the_tags($post->ID)) FOREACH ($tags as $y=>$tag) $tag_keywords[$tag->name] += 1000000+(obtg_tag_in_title($post->post_title,$tag->name))*10000-$x*100-$y;
			}ELSEIF (function_exists("UTW_ShowTagsForCurrentPost")){
				global $utw;
				FOREACH ($posts as $x=>$post) IF ($tags = $utw->GetTagsForPost($post->ID)) FOREACH($tags as $y=>$tag){
					$tag = str_replace("_"," ",$tag->tag);
					$tag = str_replace("-"," ",$tag);
					$tag = stripslashes($tag);
					$tag_keywords[$tag] += 1000000+(obtg_tag_in_title($post->post_title,$tag))*10000-$x*100-$y;
				};
			}ELSEIF (function_exists("STP_GetMetaKeywords")){
				global $STagging;
				IF ($tag_posts = $STagging->getPostTags()) FOREACH ($posts as $x=>$post) IF ($tag_posts[$post->ID]) FOREACH($tag_posts[$post->ID] as $y=>$tag) $tag_keywords[$tag] += 1000000+(obtg_tag_in_title($post->post_title,$tag))*10000-$x*100-$y;
			};
			arsort($tag_keywords);
			$tag_keywords = array_keys($tag_keywords);
			$category_keywords = array();
			FOREACH ($posts as $x=>$post) IF ($categories = get_the_category($post->ID)) FOREACH ($categories as $y=>$category) $category_keywords[$category->cat_name] += 10000-$x*100-$y;
			arsort($category_keywords);
			$category_keywords = array_keys($category_keywords);
			$tag_keywords = array_merge($tag_keywords,$category_keywords);
		};
		$obtg_tag_keywords = $tag_keywords;
	}ELSE $tag_keywords = $obtg_tag_keywords;
	$exclude = explode(", ",strtolower($exclude));
	IF (count($exclude)) FOREACH ($tag_keywords as $x=>$tag_keyword) IF (in_array(strtolower($tag_keyword),$exclude)) unset($tag_keywords[$x]);
	$dots = (count($tag_keywords) > $total_keywords)? "..." : "";
	RETURN implode(", ",array_slice($tag_keywords,0,$total_keywords)).$dots;
};
?>